from uuid import UUID

from pydantic import BaseModel, ConfigDict


class FileBaseSchema(BaseModel):
    name: str | None = None
    content: str | None = None
    folder: UUID | None = None


class FileIdSchema(BaseModel):
    id: UUID

    model_config = ConfigDict(from_attributes=True)


class FileSchema(FileBaseSchema, FileIdSchema):
    pass


class FileGetSchema(FileIdSchema):
    name: str | None = None
    content: str | None = None
    folder_id: UUID | None = None
