from uuid import UUID

from db.repositories import FileRepository
from .schemas import FileSchema


class FileService:
    file_repository = FileRepository()

    async def get_file_list(self, **kwargs):
        return await self.file_repository.get_list(**kwargs)

    async def get_file(self, id: UUID):
        return await self.file_repository.get(id)

    async def create_file(self, **kwargs):
        return await self.file_repository.create(**kwargs)

    async def update_file(self, id: UUID, **kwargs):
        return await self.file_repository.update(id, **kwargs)

    async def delete_file(self, id: UUID):
        return await self.file_repository.delete(id)
