from uuid import UUID

from db.repositories import FolderRepository
from .schemas import FolderSchema


class FolderService:
    folder_repository = FolderRepository()

    async def get_folder_list(self, **kwargs):
        return await self.folder_repository.get_list(**kwargs)

    async def get_folder(self, id: UUID):
        folder = await self.folder_repository.get(id)
        return FolderSchema.model_validate(folder)

    async def create_folder(self, **kwargs):
        folder = await self.folder_repository.create(**kwargs)
        return FolderSchema.model_validate(folder)

    async def update_folder(self, id: UUID, **kwargs):
        folder = await self.folder_repository.update(id, **kwargs)
        return FolderSchema.model_validate(folder)

    async def delete_folder(self, id: UUID):
        return await self.folder_repository.delete(id)
