from uuid import UUID

from pydantic import BaseModel, ConfigDict
from pydantic import EmailStr


class UserBaseSchema(BaseModel):
    username: str | None = None
    password: str | None = None


class UserIdSchema(BaseModel):
    id: UUID

    model_config = ConfigDict(from_attributes=True)


class UserSchema(UserBaseSchema, UserIdSchema):
    pass


class UserCreateSchema(UserBaseSchema):
    name: str
    surname: str
    email: EmailStr


class UserGetSchema(UserIdSchema):
    name: str
    surname: str
    email: EmailStr


class UserUpdateSchema(BaseModel):
    name: str
    surname: str
    email: EmailStr


class Token(BaseModel):
    access_token: str
    refresh_token: str
