from tortoise import fields

from .base import BaseModel


class User(BaseModel):
    username = fields.CharField(max_length=50, unique=True)
    name = fields.CharField(max_length=50)
    surname = fields.CharField(max_length=50)
    email = fields.CharField(max_length=50)
    password = fields.CharField(max_length=100)

    def __str__(self):
        return f'{self.surname} {self.name}'

    class Meta(BaseModel.Meta):
        table = 'users'


class Folder(BaseModel):
    name = fields.CharField(max_length=50)
    user = fields.ForeignKeyField("models.User", related_name="user_folders")

    def __str__(self):
        return self.name

    class Meta(BaseModel.Meta):
        table = 'folders'


class File(BaseModel):
    name = fields.CharField(max_length=50)
    content = fields.TextField()
    user = fields.ForeignKeyField("models.User", related_name="user_files")
    folder = fields.ForeignKeyField("models.Folder", related_name="folder_files", null=True)

    def __str__(self):
        return self.name

    class Meta(BaseModel.Meta):
        table = 'files'
